import { NgModule } from '@angular/core';
import { RouterModule } from '@angular/router';

import { AuthGuard,FullScreenGuard } from '@farmmaps/common';
import { MapComponent } from '@farmmaps/common-map';
import { LogoComponent } from './logo/logo.component';
import { MenuComponent } from './menu/menu.component';

const routes = [
  {
    path: '',
    redirectTo: 'map',
    pathMatch: 'full'
  },
  { path: 'map', canActivateChild: [AuthGuard],canActivate:[FullScreenGuard], children: [
    {
        path: '',
        component: MapComponent
    },
    {
        path: ':xCenter/:yCenter/:zoom/:rotation/:baseLayer/:queryState',
        component: MapComponent,
        children:[
          {
            path: '',
            component: LogoComponent,
            outlet: 'side-panel-logo'
          },
          {
            path: '',
            component: MenuComponent,
            outlet: 'side-panel-menu'
          }
        ]
    }
   ]},  
];

@NgModule({
  imports: [RouterModule.forRoot(routes,
    { initialNavigation: false })], // ,  enableTracing: true
  exports: [RouterModule]
})
export class AppRoutingModule { }
